



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>curator 分布式锁InterProcessMutex</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">curator 分布式锁InterProcessMutex</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 14:54:17 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>写这篇文章的目的主要是为了记录下自己在zookeeper 锁上踩过的坑,以及踩坑之后自己的一点认识;</p>
<hr />
<p>从zk分布式锁原理说起,原理很简单,大家也应该都知道,简单的说就是zookeeper实现分布式锁是通过在zk集群上的路径实现的,在获取分布式锁的时候在zk服务器集群节点上创建临时顺序节点,释放锁的时候删除该临时节点.<br />
多么简单的一句话,但是当你实现起来,想去做点优化的时候往往会变得很难,难的我们后续说;</p>
<hr />
<p>再从需求说起,需求就是加锁,但是由于原来吞吐量不是很大,只是配置了一个固定的锁路径,但是却不是每次都会去根据这个锁路径创建锁,而是将这个锁路径存放在一个本地的HashMap中,这样的话,我就没有必要每次都去重复的创建这个锁对象,简单高效的利用;</p>
<hr />
<p>变更后的需求是这样的,为了降低锁的力度,每次我要动态的生成一个path去zk上进行创建,然后再根据这个path生成锁对象,但是,一开始我依旧是沿用老的思维,想避免重复创建这个path的锁对象,于是,我想弄个三方缓存来存储这个锁对象,这时候坑就来了;</p>
<p>接下来,我们开始分析我的踩坑之旅:</p>
<pre class="prettyprint linenums"><code>public class InterProcessMutex implements InterProcessLock, Revocable&lt;InterProcessMutex&gt;<br />
{<br />
...<br />
}<br />
</code></pre>
<p>这是curator里面重入锁对象的结构,<code>InterProcessLock</code>这个是curator通用的锁接口,定义的跟jdk本身的也差不多,也是curator留给开发者自己去定制实现符合自己业务需求的锁对象的;<code>Revocable</code>接口是用来执行取消动作时触发动作用到的,如果你自定义锁对象的时候在释放锁对象时想触发一些动作,你可以实现它的方法,以上便是InterProcessLock结构的介绍;</p>
<p>看到这个代码结构我们还看出什么东西没?它并没有实现Serializable,导致其无法被序列化,也就是上面我自己想改进我业务中锁的场景就不支持了,因为类似于redis这种缓存,没法去存放一个对象,它顶多支持字符串以及<code>byte[]</code>,所以我的想法就被loss掉了;</p>
<p>即使与业务无关了,但是我们作为可爱的程序员还是有必要去研究一下这个玩意的内部实现,因为我们不知道下次我们还会遇到什么场景,所以有必要让自己刻骨铭心一次;</p>
<p>接下来,我们看其内部实现,也就是我们高大上的源码之旅:</p>
<pre class="prettyprint linenums"><code>    private final LockInternals internals;<br />
    private final String basePath;

    private final ConcurrentMap&lt;Thread, LockData&gt; threadData = Maps.newConcurrentMap();<br />
</code></pre>
<p>internals:这个是所有申请锁与释放锁的核心实现,待会我们再来讲内部实现;<br />
basePath:锁定的路径;<br />
threadData:内部缓存锁的容器;</p>
<p>实现流程主要是这样的:每次初始化<code>InterProcessMutex</code>对象的时候都会初始化一个<code>StandardLockInternalsDriver</code>对象,这个对象我们后面再讲它的使用,同时也会初始化一个LockInternals对象,</p>
<p>接下来,我们来看获取锁的代码:</p>
<pre class="prettyprint linenums"><code>public void acquire() throws Exception{<br />
        if ( !internalLock(-1, null) ) {<br />
            throw new IOException("Lost connection while trying to acquire lock: " + basePath);<br />
        }<br />
    }<br />
</code></pre>
<pre class="prettyprint linenums"><code>private boolean internalLock(long time, TimeUnit unit) throws Exception {<br />
        Thread currentThread = Thread.currentThread();<br />
        LockData lockData = threadData.get(currentThread);<br />
        if ( lockData != null )<br />
        {<br />
            // re-entering<br />
            lockData.lockCount.incrementAndGet();<br />
            return true;<br />
        }

        String lockPath = internals.attemptLock(time, unit, getLockNodeBytes());<br />
        if ( lockPath != null )<br />
        {<br />
            LockData newLockData = new LockData(currentThread, lockPath);<br />
            threadData.put(currentThread, newLockData);<br />
            return true;<br />
        }

        return false;<br />
    }<br />
</code></pre>
<p>逻辑如下:<br />
每次获取锁时会直接从本地缓存中先获取锁的元数据,如果存在,则在原有的计数器基础上+1,直接返回;<br />
否则,尝试去获取锁,逻辑如下,</p>
<pre class="prettyprint linenums"><code> String attemptLock(long time, TimeUnit unit, byte[] lockNodeBytes) throws Exception<br />
    {

        final long  startMillis = System.currentTimeMillis();<br />
         //等待时间<br />
        final Long   millisToWait = (unit != null) ? unit.toMillis(time) : null;<br />
        final byte[]    localLockNodeBytes = (revocable.get() != null) ? new byte[0] : lockNodeBytes;<br />
        int             retryCount = 0;

        String          ourPath = null;<br />
        boolean         hasTheLock = false;<br />
        boolean         isDone = false;<br />
        while ( !isDone )<br />
        {<br />
            isDone = true;

            try<br />
            {

                ourPath = driver.createsTheLock(client, path, localLockNodeBytes);<br />
                hasTheLock = internalLockLoop(startMillis, millisToWait, ourPath);<br />
            }<br />
            catch ( KeeperException.NoNodeException e )<br />
            {<br />
                // gets thrown by StandardLockInternalsDriver when it can't find the lock node<br />
                // this can happen when the session expires, etc. So, if the retry allows, just try it all again<br />
                if ( client.getZookeeperClient().getRetryPolicy().allowRetry(retryCount++, System.currentTimeMillis() - startMillis, RetryLoop.getDefaultRetrySleeper()) )<br />
                {<br />
                    isDone = false;<br />
                }<br />
                else<br />
                {<br />
                    throw e;<br />
                }<br />
            }<br />
        }

        if ( hasTheLock )<br />
        {<br />
            return ourPath;<br />
        }

        return null;<br />
    }<br />
</code></pre>
<p>首先设置一个是否有锁的标志<code>hasTheLock = false</code>,然后<br />
<code>ourPath = driver.createsTheLock(client, path, localLockNodeBytes);</code>这个地方主要是通过<code>StandardLockInternalsDriver</code>在锁目录下创建EPHEMERAL_SEQUENTIAL节点,<br />
<code>hasTheLock = internalLockLoop(startMillis, millisToWait, ourPath);</code>这里主要是循环获取锁的过程,代码看下面,首先是判断是否实现了revocable接口,如果实现了那么就对这个path设置监听,否则的话通过StandardLockInternalsDriver尝试得到PredicateResults(主要是否得到锁及需要监视的目录的两个属性);</p>
<pre class="prettyprint linenums"><code>private boolean internalLockLoop(long startMillis,Long millisToWait, String ourPath) throws Exception{<br />
        boolean     haveTheLock = false;<br />
        boolean     doDelete = false;<br />
        try{<br />
            if ( revocable.get() != null ){   client.getData().usingWatcher(revocableWatcher).forPath(ourPath);<br />
            }<br />
            while ( (client.getState() == CuratorFrameworkState.STARTED) &amp;&amp; !haveTheLock ){<br />
                List&lt;String&gt;        children = getSortedChildren();<br />
                String              sequenceNodeName = ourPath.substring(basePath.length() + 1); // +1 to include the slash

                PredicateResults    predicateResults = driver.getsTheLock(client, children, sequenceNodeName, maxLeases);<br />
                if ( predicateResults.getsTheLock() )<br />
                {<br />
                    haveTheLock = true;<br />
                }<br />
                else<br />
                {<br />
                    String  previousSequencePath = basePath + "/" + predicateResults.getPathToWatch();

                    synchronized(this)<br />
                    {<br />
                        try<br />
                        {<br />
                            // use getData() instead of exists() to avoid leaving unneeded watchers which is a type of resource leak<br />
                            client.getData().usingWatcher(watcher).forPath(previousSequencePath);<br />
                            if ( millisToWait != null )<br />
                            {<br />
                                millisToWait -= (System.currentTimeMillis() - startMillis);<br />
                                startMillis = System.currentTimeMillis();<br />
                                if ( millisToWait &lt;= 0 )<br />
                                {<br />
                                    doDelete = true;    // timed out - delete our node<br />
                                    break;<br />
                                }

                                wait(millisToWait);<br />
                            }<br />
                            else<br />
                            {<br />
                                wait();<br />
                            }<br />
                        }<br />
                        catch ( KeeperException.NoNodeException e )<br />
                        {<br />
                            // it has been deleted (i.e. lock released). Try to acquire again<br />
                        }<br />
                    }<br />
                }<br />
            }<br />
        }<br />
        catch ( Exception e )<br />
        {<br />
            ThreadUtils.checkInterrupted(e);<br />
            doDelete = true;<br />
            throw e;<br />
        }<br />
        finally<br />
        {<br />
            if ( doDelete )<br />
            {<br />
                deleteOurPath(ourPath);<br />
            }<br />
        }<br />
        return haveTheLock;<br />
    }<br />
</code></pre>
<p>然后判断PredicateResults中的pathToWatch(主要保存sequenceNode)是否是最小的节点,如果是,则得到锁,getsTheLock为true,否则得到该序列的前一个节点,设为pathToWatch,并监控起来;再判断获取锁的时间是否超时,超时则删除节点,不竞争下次锁,否则,睡眠等待获取锁;最后把获取的锁对象的锁路径等信息封装成LockData存储在本地缓存中.</p>
<p>获取锁的逻辑主要就是这些,有兴趣的同学可以打断点跟踪学习下,</p>
<hr />
<p>下面是释放锁的过程;</p>
<pre class="prettyprint linenums"><code>public void release() throws Exception<br />
    {<br />
        /*<br />
            Note on concurrency: a given lockData instance<br />
            can be only acted on by a single thread so locking isn't necessary<br />
         */

        Thread currentThread = Thread.currentThread();<br />
        LockData lockData = threadData.get(currentThread);<br />
        if ( lockData == null )<br />
        {<br />
            throw new IllegalMonitorStateException("You do not own the lock: " + basePath);<br />
        }

        int newLockCount = lockData.lockCount.decrementAndGet();<br />
        if ( newLockCount &gt; 0 )<br />
        {<br />
            return;<br />
        }<br />
        if ( newLockCount &lt; 0 )<br />
        {<br />
            throw new IllegalMonitorStateException("Lock count has gone negative for lock: " + basePath);<br />
        }<br />
        try<br />
        {<br />
            internals.releaseLock(lockData.lockPath);<br />
        }<br />
        finally<br />
        {<br />
            threadData.remove(currentThread);<br />
        }<br />
    }<br />
</code></pre>
<p>代码很简单,从本地缓存中拿到锁对象,计数器-1,只有到那个计数器=0的时候才会去执<code>internals.releaseLock(lockData.lockPath);</code></p>
<pre class="prettyprint linenums"><code>final void releaseLock(String lockPath) throws Exception<br />
    {<br />
        client.removeWatchers();<br />
        revocable.set(null);<br />
        deleteOurPath(lockPath);<br />
    }<br />
</code></pre>
<p>只要逻辑见名知意,首先移除watcher监听,这个监听可能是在循环获取锁的时候创建的,然后取消动作时触发动作时间置空,最后就是删除path;</p>
<p>最后做个小总结吧</p>
<ul><li><ol><li>curator的InterProcessLock接口提供了多种锁机制,互斥锁，读写锁,以及可定时数的互斥锁的机制(这个大家具体问题具体分析).</li></ol></li>
<li><ol><li>所有申请锁都会创建临时顺序节点,保证了都能够有机会去获取锁.</li></ol></li>
<li><ol><li>内部用了线程的wait()和notifyAll()这种等待机制,可以及时的唤醒最渴望得到锁的线程.避免常规利用Thread.sleep()这种无用的间隔等待机制.</li></ol></li>
<li><ol><li>利用redis做锁的时候,一般都需要做锁的有效时间限定。而curator则利用了zookeeper的临时顺序节点特性,一旦客户端失去连接后,则就会自动清除该节点.</li></ol></li></ul>
</div>
<p>转自：<a href="https://www.jianshu.com/p/5fa6a1464076" rel="external nofollow noreferrer">https://www.jianshu.com/p/5fa6a1464076</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390v0vo8.html">C&num; 获取当前域的路径值</a>
		</li>
						<li><a href="https://www.batexi.com/a/49532kv8.html">传说中的inside番&mdash;&mdash;&OpenCurlyDoubleQuote;黄金圣衣&rdquo;篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kv51j9.html">linux和windows共享文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1wep49.html">SharePoint 2013 配置基于AD的Form认证</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwxjgr9.html">SharedPreferences保存数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/3906rvm9.html">C&num;属性封装</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjnnvd9.html">scrollView中的pagingEnabled的功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xo44w9.html">hdu 1452 Happy 2004 膜拜这推导过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yzmz0q.html">hdu 2083</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeojxz9.html">LeetCode6 ZigZag Conversion</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k15eg59.html">keep alive的相关介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7md221q.html">自动帮助创建android资源xml文件的网站</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1p3pk8.html">HTML入门基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1gxydq.html">openstack中使用linux&lowbar;bridge实现vxlan网络</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp70459.html">javascript中Date常用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgxo1m8.html">2、搭建一个简单的Web项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj20nr9.html">万能分布式消费框架，添加基于redis中间件的方式。</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rwm368.html">Hive表种map字段的查询取用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdj4vz0q.html">for 续3</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl6vnl9.html">Cookie&amp;amp&semi;Session会话技术</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9604ngv9.html">FastReport脚本把数据绑定到文本控件上</a>
			</li>
						<li><a href="https://www.batexi.com/a/q256l5lq.html">sklearn datasets模块学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5w27mq.html">nginx代理 upstream轮询</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjxw209.html">java集合类List</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1x5dw9.html">jQuery&period;form 的最新版本是 3&period;14</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwvlld8.html">Django templates 模板的语法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllxgn0q.html">android 布局文件中xmlns&colon;android&equals;&amp;quot&semi;http&colon;&sol;&sol;schemas&period;android&period;com&sol;apk&sol;res&sol;android&amp;quot&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r1zn49.html">spring&period;factories</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvz67z8.html">esp8266&lpar;0&rpar; AT指令</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2xojpq.html">20145236《网络攻防》Exp4 恶意代码分析</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
